﻿#pragma strict

var model:String;

var position:Vector3;
var rotation:Vector3;
var scale:Vector3 = Vector3(1, 1, 1);

var disabled:String;
var randomized:String;

var randomRotation:boolean  = false;
var randomScale:boolean 	= false;

function Awake(){
	var meshModel:GameObject;
	
	if(model.Contains(',')){
		var models:String[] = model.Split(','[0]);
		var randomIndex = Random.Range(0, models.length);
		
		meshModel = Resources.Load('Models/' + models[randomIndex]) as GameObject;
	}else{
		meshModel = Resources.Load('Models/' + model) as GameObject;
	}
	
	var mesh = Instantiate(meshModel, transform.position, Quaternion.identity);
		mesh.transform.SetParent(gameObject.transform);
		
		mesh.transform.localPosition = position;
		mesh.transform.rotation 	 = Quaternion.Euler(rotation.x, rotation.y, rotation.z);
		mesh.transform.localScale    = scale;
		
		if(randomScale){ mesh.transform.localScale.y = Random.Range(0.8, 1.2); }
		if(randomRotation){
			var rotations = [0, 90, -90, 180]; var randomValue = rotations[Random.Range(0, rotations.length)];
			mesh.transform.rotation = Quaternion.Euler(rotation.x, rotation.y + randomValue, rotation.z);
			
			if(randomValue == 90) { mesh.transform.localPosition.z += 1; }
			if(randomValue == -90){ mesh.transform.localPosition.x += 1; }
			if(randomValue == 180){ mesh.transform.localPosition.z += 1; mesh.transform.localPosition.x += 1; }
		}
		
	// Disable items

	var disables:String[]; disables = disabled.Split(','[0]);
	
	var randoms:String[];  randoms = randomized.Split(','[0]);
	var activeRandom = randoms[Random.Range(0, randoms.length)];
	
	var c = mesh.GetComponentsInChildren(Transform, true);
	
	for(var i = 0; i < c.Length; i++){
		for(var j = 0; j < disables.length; j++){
			if(c[i].name == disables[j]){
				c[i].gameObject.SetActive(false);
			}
		}
		
		for(	j = 0; j < randoms.length; j++){
			if(c[i].name == randoms[j]){
				c[i].gameObject.SetActive(false);
			}
			
			if(c[i].name == activeRandom){
				c[i].gameObject.SetActive(true);
			}
		}
	}
	
}