﻿#pragma strict

import UnityEngine.EventSystems;

/* Elements */

var buildPanel:GameObject;

/* Variables */

private var speed = 0.1f;

private var cameraTargetX = 0.0f;
private var cameraTargetY = 0.0f;

private var clickX			= 0;
private var clickY			= 0;

static var selectedTile:Vector2;

var m = grid.data;

function Start(){
	
	cameraTargetX = m.length;
	cameraTargetY = m.length;
	
}

function Update(){
	
	var size = m.length;
	
	if(Input.GetKey('escape')){
		Application.Quit();
	}
	
	/* Keyboard */
	
	if(game.gameStarted && !game.building){
		if(Input.GetKey('w')){ cameraTargetX -= speed; cameraTargetY -= speed; }
		if(Input.GetKey('a')){ cameraTargetX += speed; cameraTargetY -= speed; }
		if(Input.GetKey('s')){ cameraTargetX += speed; cameraTargetY += speed; }
		if(Input.GetKey('d')){ cameraTargetX -= speed; cameraTargetY += speed; }
	}
	
	Camera.main.transform.position.x -= -(cameraTargetX - Camera.main.transform.position.x)/10;
	Camera.main.transform.position.z -= -(cameraTargetY - Camera.main.transform.position.z)/10;
	
	cameraTargetX = Mathf.Clamp(cameraTargetX, size - 6, size + 6);
	cameraTargetY = Mathf.Clamp(cameraTargetY, size - 6, size + 6);
	
	/* Mouse */
	
	var ray:Ray = Camera.main.ScreenPointToRay(Input.mousePosition);
	var hit:RaycastHit;
	
	if(Input.GetMouseButtonDown(0) && !EventSystem.current.IsPointerOverGameObject()){
		if(Physics.Raycast(ray, hit, 100)){
			
			var pos = hit.point;
				pos.x = Mathf.Floor(hit.point.x / 1) * 1;
				pos.y = 0;
				pos.z = Mathf.Floor(hit.point.z / 1) * 1;
			
			var tileID   			= m[pos.x][pos.z];			
			var tileData:Hashtable  = buildings.data[tileID];
			var tile     			= GameObject.Find('tile' + pos.x + '|' + pos.z);
			
			selectedTile = Vector2(pos.x, pos.z);
			
			if(tile && tileData['build'] == true && !game.building){
				
				sound.playSound('Audio/click', {'pitchOffset':true});
				
				game.building = true;
				game.buildMenu();
				
				/* Center camera */
				
				cameraTargetX = pos.x + 8;
				cameraTargetY = pos.z + 7;
			}
			
		}
	}
	
	if(Input.GetMouseButtonDown(1)){
		if(game.building){
			
			Destroy(GameObject.Find('circularMenu'));
			game.building = false;
			
		}
	}

	// Click 'n drag
	
	if(game.gameStarted && !game.building){
		if(Input.GetMouseButtonDown(1)){
			clickX = Input.mousePosition.x;
			clickY = Input.mousePosition.y;
		}
		
		if(Input.GetMouseButton(1)){
			cameraTargetX -= (Input.mousePosition.x - clickX)/100;
			cameraTargetY += (Input.mousePosition.x - clickX)/100;
			
			cameraTargetX -= (Input.mousePosition.y - clickY)/100;
			cameraTargetY -= (Input.mousePosition.y - clickY)/100;
			
			clickX = Input.mousePosition.x;
			clickY = Input.mousePosition.y;
		}
	}
}

function panel_build(o){
	
	if(o){
		buildPanel.SetActive(true);
	}else{
		buildPanel.SetActive(false);
	}
	
}