﻿#pragma strict

import System.IO;

var exportFolder:GameObject;
var rotation = 45;

var resetPosition:boolean = false;
var directionName:boolean = false;

function Start (){
	
	// Disable all children
	
	for(var trans:Transform in exportFolder.transform){
		trans.gameObject.SetActive(false);
	}
	
	// Go through each child
	
	for(var trans:Transform in exportFolder.transform){
		trans.gameObject.SetActive(true);
		
		// Reset position
		if(resetPosition){
			trans.localPosition = Vector3(-5, trans.localPosition.y, -5);
		}
		
		for(var i = 0; i < (360/rotation); i++){
			
			if(directionName){
				var dir = 'N';
				
				if(i == 1){ dir = 'E'; }
				if(i == 2){ dir = 'S'; }
				if(i == 3){ dir = 'W'; }
				
				capturePNG(trans.name + '_' + dir);
			}else{
				capturePNG(trans.name + '_' + i);
			}

			yield WaitForEndOfFrame();
			
			exportFolder.transform.Rotate(Vector3.up * rotation);
		}
		
		trans.gameObject.SetActive(false);
	}
	
	Debug.Log('All done!');
	
}

function capturePNG(name) {
	yield WaitForEndOfFrame();
	
	var width	= Screen.width;
	var height	= Screen.height;
	
	var tex = new Texture2D(width, height, TextureFormat.ARGB32, false);
	
	tex.ReadPixels(Rect(0, 0, width, height), 0, 0, true);
	tex.Apply();
	
	var bytes = tex.EncodeToPNG();
	Destroy(tex);
	
	File.WriteAllBytes(Application.dataPath + '/../Exported/' + name + '.png', bytes);
}