﻿#pragma strict

static var data = [ [0, 0, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 0, 0],
					[0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0],
					[0, 1, 1, 0, 0, 2, 0, 0, 0, 0, 0, 1, 1, 1, 0],
					[0, 1, 0, 0, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 0],
					[0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 2, 1, 0, 1, 0],
					[0, 1, 1, 1, 1, 0, 0, 1, 1, 1, 0, 1, 0, 1, 0],
					[0, 0, 2, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 1, 0],
					[0, 1, 1, 1, 1, 0, 1, 6, 0, 0, 0, 1, 0, 1, 4],
					[0, 1, 0, 0, 1, 0, 1, 1, 1, 1, 0, 1, 0, 0, 0],
					[0, 1, 0, 1, 1, 0, 0, 1, 0, 1, 0, 1, 1, 1, 0],
					[0, 1, 0, 1, 2, 0, 0, 1, 0, 1, 1, 0, 2, 1, 0],
					[0, 1, 0, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 0],
					[0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
					[0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0],
					[0, 0, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0]
];

function renderMap(map){
	
	for(var x = 0; x < data.length; x++){
		for(var y = 0; y < data.length; y++){
			
			var tileData:Hashtable = buildings.data[data[x][y]];
			spawnBuilding(x, y, data[x][y], false);
			
		}
	}
	
}

static function spawnBuilding(x, y, id, build){
	
	var tileData:Hashtable = buildings.data[id];
	
	var b = Instantiate(Resources.Load('Buildings/' + tileData['prefab']) as GameObject, Vector3(x, 0, y), Quaternion.identity);
		b.transform.SetParent(GameObject.Find('World').transform);
		b.name = 'tile' + x + '|' + y;
	
	if(build){
		b.transform.position.y = 0.2;
		iTween.MoveTo(b, {'y':0, 'time':0.5f, 'easetype':'easeOutBounce'});
		
		game.built = true;
	}
	
}

static function findTile(id:int){
	
	var r:Vector2 = Vector2(-1, -1);
	var tileArray:Array = new Array();
	
	for(var x = 0; x < data.length; x++){
		for(var y = 0; y < data.length; y++){
			
			if(grid.data[x][y] == id){
				tileArray.Add(Vector2(x, y));
			}
			
		}
	}
	
	var randomTile:Vector2 = tileArray[Random.Range(0, tileArray.length)];
	
	r = Vector2(randomTile.x, randomTile.y);
	
	return r;
	
}

function Start(){
	
	renderMap(data);
	
}

static function buildStructure(type:int){
	
	var tilePosition:Vector2 = controls.selectedTile;
	var tile = GameObject.Find('tile' + tilePosition.x + '|' + tilePosition.y);
	var tileData:Hashtable = buildings.data[type];
	
	var price:int = tileData['price'];
	
	sound.playSound('Audio/build', {'pitchOffset':true});
	
	game.rebels -= price;
	
	if(tile){
		
		Destroy(tile);
		grid.spawnBuilding(tilePosition.x, tilePosition.y, type, true);
		
	}
	
	data[tilePosition.x][tilePosition.y] = type;
	
}