﻿#pragma strict

static function playSound(sound:String, parameters:Hashtable){

	// Random pitch

	if(parameters['pitchOffset']){
		Camera.main.GetComponent(AudioSource).pitch = Random.Range(0.6, 1.4);
	}
	
	// Random sound from multiple, or single
	
	if(sound.Contains(',')){
		
		var sounds:String[] = sound.Split(','[0]);
		var randomIndex = Random.Range(0, sounds.length);

		Camera.main.GetComponent(AudioSource).PlayOneShot(Resources.Load(sounds[randomIndex]) as AudioClip);
	}else{
		Camera.main.GetComponent(AudioSource).PlayOneShot(Resources.Load(sound) as AudioClip);
	}
	
}

static function playTargetSound(sound:String, source:GameObject){
	
	//var audioObject_source = GameObject.Find('audioSource');
	
	//var soundClip = Resources.Load(sound);
	//audioObject_source.GetComponent(AudioSource).PlayClipAtPoint(soundClip as AudioClip, source.transform.position, 2.0f);
	
	var soundClip = Resources.Load(sound);
	PlayClipAt(soundClip, source.transform.position);
	
}

static function PlayClipAt(clip:AudioClip, pos:Vector3):AudioSource{
	var tempGO = GameObject('oneShot');
		tempGO.transform.position = pos;

		var aSource = tempGO.AddComponent(AudioSource);
			aSource.clip = clip;
			
			aSource.pitch = Random.Range(0.6, 1.4);
			aSource.spatialBlend = 1.0;
			aSource.minDistance = 1;
			aSource.maxDistance = 20;

		aSource.Play();
		Destroy(tempGO, clip.length);
	return aSource;
}